<?php
/*
geocheck_ip.php
http://css-tricks.com/snippets/php/get-geo-ip-information/
07-09-2010 modified by kristoffe brodeur.
*/
if(isset($_GET['ip']))
	{$ip=$_GET['ip'];}
else
	{$ip='72.94.171.34';}
$arrStr=geoCheckIP($ip);
//echo $arrStr;
$dataArr=explode(",",$arrStr);
$len=count($dataArr);
$table="
<table class='info'>
	<tr><td width='150px'>Node</td><td>Data</td></tr>
";
//
for($a=0;$a<$len;$a++)
	{
	$subArr=explode("^",$dataArr[$a]);
	$table.="
	<tr><td>".$subArr[0]."</td><td>".$subArr[1]."</td></tr>";
	}
$table.="</table>";
echo $table;

//Array ( [domain] => dslb-094-219-040-096.pools.arcor-ip.net [country] => DE - Germany [state] => Hessen [town] => Erzhausen )
//Get an array with geoip-infodata
function geoCheckIP($ip)
	{
    //check, if the provided ip is valid
    if(!filter_var($ip, FILTER_VALIDATE_IP))
		{
        throw new InvalidArgumentException("IP is not valid");
        }
    //contact ip-server
    $response=file_get_contents('http://www.netip.de/search?query='.$ip);
    //$response=curl_get_contents('http://www.netip.de/search?query='.$ip);
    if (empty($response))
		{
        throw new InvalidArgumentException("Error contacting Geo-IP-Server");
        }
    //Array containing all regex-patterns necessary to extract ip-geoinfo from page
	$patterns=array();
    $patterns["domain"] = '#Domain: (.*?)&nbsp;#i';
    $patterns["country"] = '#Country: (.*?)&nbsp;#i';
    $patterns["state"] = '#State/Region: (.*?)<br#i';
    $patterns["town"] = '#City: (.*?)<br#i';
    //Array where results will be stored
    $ipInfo=array();
	$dataStr="";
    //check response from ipserver for above patterns
    foreach ($patterns as $key => $pattern)
        {
        //store the result in array
        $ipInfo[$key] = preg_match($pattern,$response,$value) && !empty($value[1]) ? $value[1] : 'not found';
		$dataStr.=$key."^".$ipInfo[$key].",";
		}
    //return $ipInfo;
	// *^**,*^**,... (key)[^](value)[,]...
	$dataArr=explode(",",$dataStr);
	$finishedStr="";
	$len=count($dataArr);
	//
	for($a=0;$a<$len-2;$a++)
		{
		$finishedStr.=$dataArr[$a].",";
		}
	$finishedStr.=$dataArr[$a];
	return $finishedStr;
    }
?>